#!/usr/bin/perl
use strict;
use warnings;
use lib '..';

BEGIN {
        require "include/config.pm";
        eval {
                require "include/config.local.pm";
        };
}



my $f = open(SWITCHES, "../switches.txt");
my $p = open(PATCH, "../patchlist.txt");

my $eterkanal = 101;
my $eterkanalcrew = 1;
my $letter = "a";

my %switches;
while(<SWITCHES>) {
	chomp;
	my ($network, $netmask, $switchname, $mngmt_ip) = split / /; # $mngmt_ip is unused
	$switches{$switchname} = {
		network => $network,
		netmask => $netmask,
	};	
}
while (<PATCH>) {
	chomp;
	my ($switchname, $coregw1, $port1, $coregw2, $port2) = split / /;
	my ($o1, $o2, $o3, $o4) = split(/\./, $switches{$switchname}{network});
	my $v6addr = $nms::config::base_ipv6net.$o3. $letter ."::1/64";

	if ($o4 eq "0") {
		$letter = "a";
	} elsif ($o4 eq "128") {
		$letter = "b";
	} 

	$o4 += 1;
	my $gateway_addr = "$o1.$o2.$o3.$o4";
	$o4 += 1;
	my $switch_addr = "$o1.$o2.$o3.$o4";

	my $ether;
	if ($coregw1 eq 'crew') {
		$ether = $eterkanalcrew;
		$eterkanalcrew++;
	} else {
		$ether = $eterkanal;
		$eterkanal++;
	}
	print "$switchname $coregw1 $port1 $port2 $ether $switch_addr $gateway_addr $v6addr\n";

	die("NO MORE ETHERCHANNELS!") if($eterkanal > 256);

}
