#!/usr/bin/perl

use warnings;
use strict;

use CGI;
my $client = CGI->new;

my $stream = $client->param('stream');
my $interlaced = $client->param('interlaced');
my $unicast = $client->param('unicast');

my $url = "";
my $port = "";
my $extinf = "";

my $clip = $client->remote_addr();

if($clip =~ /^2a01:798:76a|^188\.0/) {
	#UDP-url if we don't force unicast
	if(defined $unicast) {
		$url = "http://stream.tg11.gathering.org:30";
	} elsif($stream eq "flash"){
		$url = "http://stream.tg11.gathering.org:";
	} else {
		$url = "udp://\@239.192.168.7:20";
		$extinf .= "Multicasted";
	}	
} else {
	#Unicast-url
	$url = "http://stream.tg11.gathering.org:30";
	$extinf .= "unicast";
}

if($stream eq "hd") {
	$port = "14"; 
	$extinf .= " Main Stream (HD) (720p50)"
} elsif ($stream eq "sd") { 
	$port = "13";
	$extinf .= " Main Stream (SD) (576p50)"
} elsif ($stream eq "creativia") {
	$port = "15";
	$extinf .= " Creativia (HD) (720p50)"
} elsif ($stream eq "flash") {
	$port = "5013/stream.flv";
	$extinf .= " Flash"
}

if(not defined $stream) {
	print $client->header();
	print "No stream, robots unhappy :/\n";
	return;
}
print $client->header(-type => "application/vlc",
			"-Content-disposition" => "attachment; filename=tg-stream.vlc"
);

print "#EXTM3U\n";
print "#EXTINF:-1,TG11 $extinf\n";
if(defined $interlaced) {
	print "#EXTVLCOPT:deinterlace=1\n";
	print "#EXTVLCOPT:deinterlace-mode=linear\n";
}
print "$url$port\n";

