#!/usr/bin/perl

use warnings;
use strict;

use CGI;
my $client = CGI->new;

my $stream = $client->param('stream');
my $interlaced = $client->param('interlaced');
my $unicast = $client->param('unicast');
my $delivery = $client->param('delivery');

#default
if (not defined $delivery) {
	$delivery = "multicast";
}

if((not defined $stream) or (not defined $delivery)) {
	print $client->header();
	die "No stream and/or delivery method, robots unhappy :/\n";
}

my $url = "";
my $port_del = "";
my $port_str = "";
my $extinf = "";
my $flash_appendix = "";

my $clip = $client->remote_addr();

#We use two first digits to select the delivery method.
if ($delivery eq "multicast") {
	$port_del = "20";
	$url = "udp://\@239.192.168.7";
	$extinf .= "Multicasted";
} elsif ($delivery eq "unicast") {
	$port_del = "30";
	$url = "http://stream.tg11.gathering.org";
	$extinf .= "Unicasted";
} 
#the last two digits selects the stream. 
if($stream eq "hd") {
	$port_str = "14"; 
	$extinf .= " Main Stream (HD) (720p50)";
} elsif ($stream eq "sd") { 
	$port_str = "13";
	$extinf .= " Main Stream (SD) (576p50)";
} elsif ($stream eq "creativia") {
	$port_str = "15";
	$extinf .= " Creativia (HD) (720p50)";
} elsif ($stream eq "creativiasd") {
        $port_str = "16";
        $extinf .= " Creativia (SD) (576p50)";
} elsif ($stream eq "creativiaflash") {
        $port_del = "50"; #special case, messy :/
        $port_str = "15";
        $url = "http://stream.tg11.gathering.org";
        $flash_appendix = "/stream.flv";
        $extinf .= " Creativia (Low Bitrate/Flash)";
} elsif ($stream eq "flash") {
	$port_del = "50"; #special case, messy :/
	$port_str = "13";
	$url = "http://stream.tg11.gathering.org";
	$flash_appendix = "/stream.flv";	
	$extinf .= " Main Stream (Low Bitrate/Flash)";
}

#print out new file
print $client->header(-type => "application/vlc",
			"-Content-disposition" => "attachment; filename=tg-".$delivery."-".$stream.".vlc"
);

print "#EXTM3U\n";
print "#EXTINF:-1,TG11 $extinf\n";
if(defined $interlaced) {
	print "#EXTVLCOPT:deinterlace=1\n";
	print "#EXTVLCOPT:deinterlace-mode=linear\n";
}
print "$url:$port_del$port_str$flash_appendix\n";

