#!/usr/bin/perl -I /root/tgmanage
use strict;

BEGIN {
        require "include/config.pm";
        eval {
                require "include/config.local.pm";
        };
}

my $bind_base = "/etc/bind/";
my $dhcpd_base = "/etc/dhcp/";

my $shellconf_file = "include/tgmanage.cfg.sh";

my $tgname    = $nms::config::tgname;

my $pri_a     = $nms::config::pri_a;
my $pri_ptr   = $nms::config::pri_ptr;
my $pri_v6    = $nms::config::pri_v6;

my $sec_a     = $nms::config::sec_a;
my $sec_ptr   = $nms::config::sec_ptr;
my $sec_v6    = $nms::config::sec_v6;

my $ddns_key  = $nms::config::ddns_key;

my $base_ipv4net    = $nms::config::base_ipv4net;
my $base_ipv4prefix = $nms::config::base_ipv4prefix;

my $base_ipv6net    = $nms::config::base_ipv6net;
my $base_ipv6prefix = $nms::config::base_ipv6prefix;

open CFG, ">" . $shellconf_file or die ($! . " " . $shellconf_file );

print CFG "# This file is autogenerated by tools/create-shellconf.pl,\n";
print CFG "# using data from nms::config.\n";
print CFG "#\n";
print CFG "# Do you need new common/configuration variables?\n";
print CFG "# Add/update include/config.local.pm and tools/create-shellconf.pl\n\n";
print CFG "PRIMARY=\"$pri_a.$tgname.gathering.org\"\n";
print CFG "SECONDARY=\"$sec_a.$tgname.gathering.org\"\n";
print CFG "TGNAME=\"$tgname\"\n\n";
print CFG "PRI_PTR=\"$pri_ptr\"\n";
print CFG "SEC_PTR=\"$sec_ptr\"\n\n";
print CFG "DDNS_KEY=\"$ddns_key\"\n\n";
print CFG "BASEV4=\"$base_ipv4net\"\n";
print CFG "PREFIXV4=\"$base_ipv4prefix\"\n";
print CFG "BASEV6=\"$base_ipv6net\"\n";
print CFG "PREFIXV6=\"$base_ipv6prefix\"\n";
close CFG;
