#!/usr/bin/perl
use strict;

BEGIN {
        require "include/config.pm";
        eval {
                require "include/config.local.pm";
        };
}

use Net::IP;

while (<STDIN>)
{
	my ( $sysname, $distro, $int1, $int2, $ponum, $ipaddr, $gwaddr, $v6addr ) = split /\s+/, $_;
	my ( $p, $s, $t, $f ) = split /\./, $ipaddr;
	my $ip = new Net::IP($ipaddr);
	my ($foo, undef) =  split /\//, $v6addr;
	my $v6 = new Net::IP( $foo ) or die ( "Net::IP($foo)");
	my $fqdn = "sw." . $sysname . "." . $nms::config::tgname . ".gathering.org.";
	my $text_info = $distro . " - " . $int1 . " + " . $int2 . ", po" . $ponum . ", gwaddr " . $gwaddr;
	print "prereq nxdomain " . $fqdn . "\n";
	print "update add " . $fqdn . " \t 3600 IN A \t " . $ipaddr . "\n";
	print "send\n";
	print "update add " . $fqdn . " \t 3600 IN AAAA \t " . $foo . "\n";
	print "send\n";
	print "prereq nxdomain " . $ip->reverse_ip() . "\n";
	print "update add " . $ip->reverse_ip() . " \t 3600 IN PTR \t " . $fqdn . "\n";
	print "send\n";
	print "prereq nxdomain " . $v6->reverse_ip() . "\n";
	print "update add " . $v6->reverse_ip() . " \t 3600 IN PTR \t " . $fqdn . "\n";
	print "send\n";
	print "update delete " . $fqdn . " IN TXT\n";
	print "update add " . $fqdn . " \t 3600 IN TXT \t \"" . $text_info . "\"\n";
	print "send\n";

}

